Public Class frmVBasicEx_02

    'Step 1: Add MeOCR Lib to your project. Load meocrlib.dll reference;

    'Step 2: Declare your object variable
    Private ocrPuma As New MeOCRLib.Puma


    Private Sub frmVBasicEx_02_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        'Step 3: Initialize the engine and pass the callback function.
        ocrPuma.Init(AddressOf PumaProgress)

        'Step 4: Set the language.
        ocrPuma.Language = 0      ' 0 for English       

        'Step 5: Set the Output format.
        ocrPuma.OutputFormat = 2  ' Formatted text

        'Example of enumerating supported languages by populate a language drop down list.
        LoadLaguagesList()
    End Sub

    Private Sub btnRecognize_Click(sender As Object, e As EventArgs) Handles btnRecognize.Click
        'Set wait cursor
        Cursor.Current = Cursors.WaitCursor

        'Get the image path. You may need to change this or just copy Sample_02.tif into bin folder.
        Dim FileName As String = System.IO.Path.GetDirectoryName(Environment.GetCommandLineArgs()(0)) & "\Sample_02.tif"

        Try
            'Load the image.
            Dim imgPuma As Image = Image.FromFile(FileName)

            'Step 6: Recognize the image.
            textOut.Text = ocrPuma.Recognize(imgPuma)

            'Demonstrates parsing of Raw Format
            If ocrPuma.OutputFormat = 0 Then
                ParseResults(textOut.Text)
            End If

        Catch ex As System.IO.FileNotFoundException

            MessageBox.Show(Me, "File not found. [" & FileName & "] " & vbCr & vbCr & "Did you forget to set the correct image path and make sure the image exists there?", Me.Text)

        End Try

        'Restore default cursor
        Cursor.Current = Cursors.Default

    End Sub

    '-----------------------------------------------------------
    'Progess bar callback function
    '-----------------------------------------------------------
    'Does not get called when inside the designer (IDE). 
    'To see it operate correctly run the application outside the IDE.
    '-----------------------------------------------------------
    Sub PumaProgress(pStep As Integer, PStepName As String, LPercent As Integer)
        btnRecognize.Text = LPercent & "% - " & PStepName
    End Sub


    Private Sub rbRaw_CheckedChanged(sender As Object, e As EventArgs) Handles rbRaw.CheckedChanged
        btnRecognize.Text = "Click Here To Recognize"
        If rbRaw.Checked Then
            ocrPuma.OutputFormat = Convert.ToInt16(rbRaw.Tag)
        End If
    End Sub

    Private Sub cmbLanguages_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cmbLanguages.SelectedIndexChanged
        'Set the language selected
        ocrPuma.Language = cmbLanguages.SelectedIndex
    End Sub

    '-----------------------------------------------------------
    'Enumerate Languages and load them into cmbLanguages. English is 0  
    '-----------------------------------------------------------
    Private Sub LoadLaguagesList()
        Dim lIndex As Integer = 0
        Dim langStr As String = ocrPuma.LanguageString(lIndex)
        While (langStr <> "")
            If (langStr <> "Reserved") Then
                cmbLanguages.Items.Add(langStr)
            End If
            lIndex = lIndex + 1
            langStr = ocrPuma.LanguageString(lIndex)
        End While
        cmbLanguages.SelectedIndex = ocrPuma.Language
    End Sub

    Private Sub rbPlain_CheckedChanged(sender As Object, e As EventArgs) Handles rbPlain.CheckedChanged
        btnRecognize.Text = "Click Here To Recognize"
        If rbPlain.Checked Then
            ocrPuma.OutputFormat = Convert.ToInt16(rbPlain.Tag)
        End If
    End Sub

    Private Sub rbFormatted_CheckedChanged(sender As Object, e As EventArgs) Handles rbFormatted.CheckedChanged
        btnRecognize.Text = "Click Here To Recognize"
        If rbFormatted.Checked Then
            ocrPuma.OutputFormat = Convert.ToInt16(rbFormatted.Tag)
        End If
    End Sub

    '-----------------------------------------------------------
    'Demonstrates parsing of Raw Format
    '-----------------------------------------------------------
    Private Sub ParseResults(chars As String)
        Dim numItems As Integer = -1

        If chars <> "" Then
            Dim charToks As String() = chars.Split(ControlChars.Cr)

            For Each Tok As String In charToks
                If numItems = -1 Then
                    numItems = Convert.ToInt32(Tok)
                Else

                    Dim TokData As String() = Tok.Split(ChrW(1))
                    If TokData(0) <> "" Then

                        Select Case TokData(0)(0)
                            Case " "
                                'Specifies the end of a word.
                                Exit Select

                            Case ChrW(2)
                                'Specifies the end of a line fragment.	
                                Exit Select
                            Case Else

                                'OCR character
                                Dim OCRChar As String = TokData(0)(0)
                                Dim Left As Integer = Convert.ToInt32(TokData(1))
                                Dim Top As Integer = Convert.ToInt32(TokData(2))
                                Dim Right As Integer = Convert.ToInt32(TokData(3))
                                Dim Bottom As Integer = Convert.ToInt32(TokData(4))
                                Exit Select

                                'switch (TokData[0][0])
                        End Select
                        'if (TokData[0] != "")
                    End If
                    'if (numItems == -1)

                End If
                'foreach (string Tok in charToks)
            Next
        End If
        'if (chars != "")
    End Sub

End Class
